From: Johannes Sixt <j.sixt@viscovery.net>
To: Junio C Hamano <gitster@pobox.com>
Cc: Git Mailing List <git@vger.kernel.org>
Subject: [PATCH] test suite: add a check that all test numbers are unique
Date: Fri, 21 Aug 2009 11:28:15 +0200 [thread overview]
Message-ID: <4A8E68AF.8040001@viscovery.net> (raw)
From: Johannes Sixt <j6t@kdbg.org>
The test runs only if 'make all' is used. Its purpose is to alert our
valued integrator if different branches are merged that happen to
introduce the same test number.
Signed-off-by: Johannes Sixt <j6t@kdbg.org>
---
t/Makefile | 1 +
t/check_unique_numbers.sh | 27 +++++++++++++++++++++++++++
2 files changed, 28 insertions(+), 0 deletions(-)
create mode 100755 t/check_unique_numbers.sh
diff --git a/t/Makefile b/t/Makefile
index bd09390..2a451b7 100644
--- a/t/Makefile
+++ b/t/Makefile
@@ -17,6 +17,7 @@ T = $(wildcard t[0-9][0-9][0-9][0-9]-*.sh)
TSVN = $(wildcard t91[0-9][0-9]-*.sh)
all: pre-clean
+ '$(SHELL_PATH_SQ)' ./check_unique_numbers.sh
$(MAKE) aggregate-results-and-cleanup
$(T):
diff --git a/t/check_unique_numbers.sh b/t/check_unique_numbers.sh
new file mode 100755
index 0000000..e767275
--- /dev/null
+++ b/t/check_unique_numbers.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+# checks whether test case numbers are unique;
+# returns non-zero if any duplicates were found
+
+check_numbers () {
+ last= dup=
+ while read name
+ do
+ case $name in
+ t[0-9][0-9][0-9][0-9]-*.sh)
+ number=${name%%-*}
+ if test "$number" = "$last"; then
+ dup="$dup $number"
+ fi
+ last=$number
+ ;;
+ esac
+ done
+ test -z "$dup" || {
+ echo >&2 "error: duplicate test numbers:" $dup
+ return 1
+ }
+}
+
+ls -1 | # no wildcard to avoid overflow of command line
+check_numbers
--
1.6.4.204.g6aad7
next reply other threads:[~2009-08-21 9:28 UTC|newest]
Thread overview: 4+ messages / expand[flat|nested] mbox.gz Atom feed top
2009-08-21 9:28 Johannes Sixt [this message]
2009-08-21 12:53 ` [PATCH] test suite: add a check that all test numbers are unique Jeff King
2009-08-21 13:13 ` [PATCH v2] " Johannes Sixt
2009-08-21 14:37 ` Jeff King
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=4A8E68AF.8040001@viscovery.net \
--to=j.sixt@viscovery.net \
--cc=git@vger.kernel.org \
--cc=gitster@pobox.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.